#!/usr/bin/env node
'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;
exports.provisionGit = provisionGit;

var _packagesmithFormatsIni = require('packagesmith.formats.ini');

var _packagesmithFormatsIni2 = _interopRequireDefault(_packagesmithFormatsIni);

var _packagesmithFormatsMultiline = require('packagesmith.formats.multiline');

var _packagesmithFormatsMultiline2 = _interopRequireDefault(_packagesmithFormatsMultiline);

var _packagesmithQuestionsRepository = require('packagesmith.questions.repository');

var _packagesmithQuestionsRepository2 = _interopRequireDefault(_packagesmithQuestionsRepository);

var _lodashDefaultsdeep = require('lodash.defaultsdeep');

var _lodashDefaultsdeep2 = _interopRequireDefault(_lodashDefaultsdeep);

var _packagesmith = require('packagesmith');

function provisionGit() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var _ref$init = _ref.init;
  var init = _ref$init === undefined ? true : _ref$init;
  var _ref$setupGitConfig = _ref.setupGitConfig;
  var setupGitConfig = _ref$setupGitConfig === undefined ? true : _ref$setupGitConfig;
  var _ref$gitConfigOptions = _ref.gitConfigOptions;
  var gitConfigOptions = _ref$gitConfigOptions === undefined ? { whitespace: true } : _ref$gitConfigOptions;
  var _ref$gitignoreLines = _ref.gitignoreLines;
  var gitignoreLines = _ref$gitignoreLines === undefined ? false : _ref$gitignoreLines;
  var gitIgnoreOptions = _ref.gitIgnoreOptions;

  var provision = {};
  if (init) {
    provision['.git'] = {
      type: 'folder',
      command: 'git init -q'
    };
  }
  if (Array.isArray(gitignoreLines) && gitignoreLines.length) {
    provision['.gitignore'] = {
      contents: _packagesmithFormatsMultiline2['default'](function (gitIgnore) {
        return [].concat(gitIgnore, gitignoreLines);
      }, gitIgnoreOptions)
    };
  }
  if (setupGitConfig) {
    provision['.git/config'] = {
      questions: [_packagesmithQuestionsRepository2['default']()],
      contents: _packagesmithFormatsIni2['default'](function (gitConfig, _ref2) {
        var repository = _ref2.repository;
        return _lodashDefaultsdeep2['default'](gitConfig, {
          'remote "origin"': {
            url: repository,
            fetch: '+refs/heads/*:refs/remotes/origin/*'
          }
        }, gitConfig);
      }, gitConfigOptions)
    };
  }
  return provision;
}

exports['default'] = provisionGit;

if (require.main === module) {
  _packagesmith.runProvisionerSet(process.argv[2] || '.', provisionGit());
}